#include "stdafx.h"
#include "MT19937_F.h"
#include "PassingArray.h"

using namespace random::dll::mt19937_f;
/* methodes ---------- -------------- -------------- --------------*/
template <typename T>
void set_zero_2dj(T ** buffer, i32 szbuffer1, i32 szbuffer2) {
	for (int i = 0; i < szbuffer1; ++i) {
		for (int j = 0; j < szbuffer2; ++j) {
			buffer[i][j] = 0;
		}
	}
}
template <typename T>
void set_zero_3dj(T *** buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3) {
	for (int i = 0; i < szbuffer1; ++i) {
		for (int j = 0; j < szbuffer2; ++j) {
			for (int z = 0; z < szbuffer3; ++z) {
				buffer[i][j][z] = 0;
			}
		}
	}
}
template <typename T>
void delete_2dj(T ** buffer, i32 szbuffer1) {
	if (buffer != 0) {
		for (int i = 0; i < szbuffer1; ++i) {
			if (buffer[i] != 0){
				delete[] buffer[i];
				buffer[i] = 0;
			}
		}
		delete[] buffer;
		buffer = 0;
	}
}
template <typename T>
void delete_3dj(T *** buffer, i32 szbuffer1, i32 szbuffer2) {
	if (buffer != 0) {
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				if (buffer[i][j] != 0){
					delete[] buffer[i][j];
					buffer[i][j] = 0;
				}
			}
			delete[] buffer[i];
			buffer[i] = 0;
		}
		delete[] buffer;
		buffer = 0;
	}
}

/* byte -------------- -------------- -------------- --------------*/
b8*		BUFFER_BYT = 0;
b8*		BUFFER_BYT_2D = 0;
b8*		BUFFER_BYT_3D = 0;
b8**	BUFFER_BYT_2DJ = 0;
b8***	BUFFER_BYT_3DJ = 0;
i32		sz_byt_2d = -1, sz_byt_3d = -1;
i32		sz_byt_2dj = -1, sz_byt_3dj1 = -1, sz_byt_3dj2 = -1;
b8 * APIENTRY create_rng_byt(i32 szbuffer)
{
	if (szbuffer > 0)
	{
		b8** res = 0;
		res = &BUFFER_BYT;
		if (!*res)delete[](*res), (*res) = 0;
		*res = new b8[szbuffer + 1];
		memset(*res, 0, szbuffer + 1);
		next_byte(*res, szbuffer);

		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_byt(b8 * buffer, i32 szbuffer)
{
	if (buffer && szbuffer > 0)
	{
		memset(buffer, 0, szbuffer);
		next_byte(buffer, szbuffer);
		return szbuffer;
	}
	return -1;
}

b8 * APIENTRY create_rng_byt_2d(i32 szbuffer1, i32 szbuffer2)
{
	if (szbuffer1 > 0 && szbuffer2 > 0)
	{
		b8 ** res = 0 ;
		res = &BUFFER_BYT_2D;
		if ((*res) != 0)delete[] BUFFER_BYT_2D, (*res) = 0;
		* res = new b8[szbuffer1 * szbuffer2 + 1];
		memset(*res, 0, szbuffer1 * szbuffer2 + 1);
		next_byte(*res, szbuffer1 * szbuffer2);
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_byt_2d(b8 * buffer, i32 szbuffer1, i32 szbuffer2)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0)
	{
		memset(buffer, 0, szbuffer1 * szbuffer2);
		next_byte(buffer, szbuffer1 * szbuffer2);
		return szbuffer1 * szbuffer2;
	}
	return -1;
}
b8 * APIENTRY create_rng_byt_3d(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		b8 **res = 0;
		res = &BUFFER_BYT_3D;
		if ((*res) != 0)delete[] BUFFER_BYT_3D, (*res) = 0;
		*res = new b8[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(*res, 0, szbuffer1 * szbuffer2 * szbuffer3 + 1);
		next_byte(*res, szbuffer1 * szbuffer2 * szbuffer3);

		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_byt_3d(b8 * buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		memset(buffer, 0, szbuffer1 * szbuffer2 * szbuffer3);
		next_byte(buffer, szbuffer1 * szbuffer2 * szbuffer3);
		return szbuffer1 * szbuffer2 * szbuffer3;
	}
	return -1;
}
b8 ** APIENTRY create_rng_byt_2dj(i32 szbuffer1, i32 szbuffer2)
{
	if (szbuffer1 > 0 && szbuffer2 > 0)
	{
		b8 *** res = 0;
		res = &BUFFER_BYT_2DJ;
		if ((*res) != 0)delete_2dj(*res, sz_byt_2dj), (*res) = 0;
		sz_byt_2dj = szbuffer1;

		*res = new b8*[szbuffer1];
		for (int i = 0; i < szbuffer1; ++i) {
			(*res)[i] = new b8[szbuffer2 + 1];
			memset((*res)[i], 0, szbuffer2 + 1);
		}

		i32 it = 0;
		b8* tmp = new b8[szbuffer1 * szbuffer2 + 1];
		memset(tmp, 0, szbuffer1 * szbuffer2 + 1);
		next_byte(tmp, szbuffer1 * szbuffer2);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				(*res)[i][j] = tmp[it++];
			}
		}
		delete[] tmp;
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_byt_2dj(b8 ** buffer, i32 szbuffer1, i32 szbuffer2)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0)
	{
		i32 it = 0;
		set_zero_2dj(buffer, szbuffer1, szbuffer2);
		b8* tmp = new b8[szbuffer1 * szbuffer2 + 1];
		memset(tmp, 0, szbuffer1 * szbuffer2 + 1);
		next_byte(tmp, szbuffer1 * szbuffer2);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				buffer[i][j] = tmp[it++];
			}
		}
		delete[] tmp;
		return szbuffer1 * szbuffer2;
	}
	return -1;
}
b8 *** APIENTRY create_rng_byt_3dj(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		b8 **** res = 0;
		res = &BUFFER_BYT_3DJ;
		if (*res != 0)delete_3dj(*res, sz_byt_3dj1, sz_byt_3dj2), (*res) = 0;
		sz_byt_3dj1 = szbuffer1; sz_byt_3dj2 = szbuffer2;

		*res = new b8**[szbuffer1];
		for (int i = 0; i < szbuffer1; ++i) {
			(*res)[i] = new b8*[szbuffer2];
			for (int j = 0; j < szbuffer2; ++j) {
				(*res)[i][j] = new b8[szbuffer3 + 1];
				memset((*res)[i][j], 0, szbuffer3 + 1);
			}
		}
		set_zero_3dj(*res, szbuffer1, szbuffer2, szbuffer3);

		i32 it = 0;
		b8* tmp = new b8[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(tmp, 0, szbuffer1 * szbuffer2 * szbuffer3 + 1);
		next_byte(tmp, szbuffer1 * szbuffer2 * szbuffer3);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				for (int z = 0; z < szbuffer3; ++z) {
					(*res)[i][j][z] = tmp[it++];
				}
			}
		}
		delete[] tmp;
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_byt_3dj(b8 *** buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		set_zero_3dj(buffer, szbuffer1, szbuffer2, szbuffer3);

		i32 it = 0;
		b8* tmp = new b8[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(tmp, 0, szbuffer1 * szbuffer2 * szbuffer3 + 1);
		next_byte(tmp, szbuffer1 * szbuffer2 * szbuffer3);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				for (int z = 0; z < szbuffer3; ++z) {
					buffer[i][j][z] = tmp[it++];
				}
			}
		}
		delete[] tmp;
		return szbuffer1 * szbuffer2 * szbuffer3;
	}
	return -1;
}

/* i32 -------------- -------------- -------------- --------------*/
i32*	BUFFER_i32 = 0;
i32*	BUFFER_i32_2D = 0;
i32*	BUFFER_i32_3D = 0;
i32**	BUFFER_i32_2DJ = 0;
i32***	BUFFER_i32_3DJ = 0;
i32		sz_i32_2d = -1, sz_i32_3d = -1;
i32		sz_i32_2dj = -1, sz_i32_3dj1 = -1, sz_i32_3dj2 = -1;
i32 * APIENTRY create_rng_i32(i32 szbuffer)
{
	if (szbuffer > 0) {
		i32** res = 0;
		res = &BUFFER_i32;
		if ((*res) != 0)delete[](*res), (*res) = 0;
		*res = new i32[szbuffer + 1];
		memset(*res, 0, (szbuffer + 1) * sizeof(i32));
		next(*res, szbuffer);
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_i32(i32 * buffer, i32 szbuffer)
{
	if (buffer && szbuffer > 0)
	{
		memset(buffer, 0, szbuffer * sizeof(i32));
		next(buffer, szbuffer);
		return szbuffer;
	}
	return -1;
}

i32 * APIENTRY create_rng_i32_2d(i32 szbuffer1, i32 szbuffer2)
{
	if (szbuffer1 > 0 && szbuffer2 > 0)
	{
		i32 ** res = 0;
		res = &BUFFER_i32_2D;
		if ((*res) != 0) delete[](*res), (*res) = 0;
		*res = new i32[szbuffer1*  szbuffer2 + 1];
		memset(*res, 0, (szbuffer1* szbuffer2 + 1) * sizeof(i32));
		next(*res, szbuffer1 * szbuffer2);
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_i32_2d(i32 * buffer, i32 szbuffer1, i32 szbuffer2)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0)
	{
		memset(buffer, 0, (szbuffer1 * szbuffer2) * sizeof(i32));
		next(buffer, szbuffer1 * szbuffer2);
		return szbuffer1 * szbuffer2;
	}
	return -1;
}

i32 * APIENTRY create_rng_i32_3d(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		i32 ** res = 0;
		res = &BUFFER_i32_3D;
		if ((*res) != 0) delete[](*res), (*res) = 0;
		*res = new i32[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(*res, 0, (szbuffer1 * szbuffer2 * szbuffer3 + 1) * sizeof(i32));
		next(*res, szbuffer1 * szbuffer2 * szbuffer3);
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_i32_3d(i32 * buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		memset(buffer, 0, (szbuffer1 * szbuffer2 * szbuffer3) * sizeof(i32));
		next(buffer, szbuffer1 * szbuffer2 * szbuffer3);
		return szbuffer1 * szbuffer2 * szbuffer3;
	}
	return -1;
}

i32 ** APIENTRY create_rng_i32_2dj(i32 szbuffer1, i32 szbuffer2)
{
	if (szbuffer1 > 0 && szbuffer2 > 0)
	{
		i32 *** res = 0;
		res = &BUFFER_i32_2DJ;
		if ((*res) != 0) delete_2dj(*res, sz_i32_2dj), (*res) = 0;
		sz_i32_2dj = szbuffer1;

		*res = new i32*[szbuffer1];
		for (int i = 0; i < szbuffer1; ++i) {
			(*res)[i] = new i32[szbuffer2 + 1];
			memset((*res)[i], 0, (szbuffer2 + 1) * sizeof(i32));
		}

		i32 it = 0;
		i32* tmp = new i32[szbuffer1 * szbuffer2 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 + 1) * sizeof(i32));
		next(tmp, szbuffer1 * szbuffer2);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				(*res)[i][j] = tmp[it++];
			}
		}
		delete[] tmp;
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_i32_2dj(i32 ** buffer, i32 szbuffer1, i32 szbuffer2)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0)
	{
		i32 it = 0;
		set_zero_2dj(buffer, szbuffer1, szbuffer2);
		i32* tmp = new i32[szbuffer1 * szbuffer2 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 + 1) * sizeof(i32));
		next(tmp, szbuffer1 * szbuffer2);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				buffer[i][j] = tmp[it++];
			}
		}
		delete[] tmp;
		return szbuffer1 * szbuffer2;
	}
	return -1;
}

i32 *** APIENTRY create_rng_i32_3dj(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		i32 **** res = 0;
		res = &BUFFER_i32_3DJ;
		if ((*res) != 0) delete_3dj(res, sz_i32_3dj1, sz_i32_3dj2), (*res) = 0;
		sz_i32_3dj1 = szbuffer1; sz_i32_3dj2 = szbuffer2;

		*res = new i32**[szbuffer1];
		for (int i = 0; i < szbuffer1; ++i) {
			(*res)[i] = new i32*[szbuffer2];
			for (int j = 0; j < szbuffer2; ++j) {
				(*res)[i][j] = new i32[szbuffer3 + 1];
				memset((*res)[i][j], 0, (szbuffer3 + 1) * sizeof(i32));
			}
		}
		set_zero_3dj(*res, szbuffer1, szbuffer2, szbuffer3);

		i32 it = 0;
		i32* tmp = new i32[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 * szbuffer3 + 1) * sizeof(i32));
		next(tmp, szbuffer1 * szbuffer2 * szbuffer3);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				for (int z = 0; z < szbuffer3; ++z) {
					(*res)[i][j][z] = tmp[it++];
				}
			}
		}
		delete[] tmp;
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_i32_3dj(i32 *** buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		set_zero_3dj(buffer, szbuffer1, szbuffer2, szbuffer3);

		i32 it = 0;
		i32* tmp = new i32[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 * szbuffer3 + 1) * sizeof(i32));
		next(tmp, szbuffer1 * szbuffer2 * szbuffer3);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				for (int z = 0; z < szbuffer3; ++z) {
					buffer[i][j][z] = tmp[it++];
				}
			}
		}
		delete[] tmp;
		return szbuffer1 * szbuffer2 * szbuffer3;
	}
	return -1;
}

/* i64 -------------- -------------- -------------- --------------*/
i64*	BUFFER_i64 = 0;
i64*	BUFFER_i64_2D = 0;
i64*	BUFFER_i64_3D = 0;
i64**	BUFFER_i64_2DJ = 0;
i64***	BUFFER_i64_3DJ = 0;
i32		sz_i64_2d = -1, sz_i64_3d = -1;
i32		sz_i64_2dj = -1, sz_i64_3dj1 = -1, sz_i64_3dj2 = -1;
i64 * APIENTRY create_rng_i64(i32 szbuffer)
{
	if (szbuffer > 0) {
		i64** res = 0;
		res = &BUFFER_i64;
		if ((*res) != 0)delete[](*res), (*res) = 0;
		*res = new i64[szbuffer + 1];
		memset(*res, 0, (szbuffer + 1) * sizeof(i64));
		next_i64(*res, szbuffer);
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_i64(i64 * buffer, i32 szbuffer)
{
	if (buffer && szbuffer > 0)
	{
		memset(buffer, 0, szbuffer * sizeof(i64));
		next_i64(buffer, szbuffer);
		return szbuffer;
	}
	return -1;
}

i64 * APIENTRY create_rng_i64_2d(i32 szbuffer1, i32 szbuffer2)
{
	if (szbuffer1 > 0 && szbuffer2 > 0)
	{
		i64** res = 0;
		res = &BUFFER_i64_2D;
		if ((*res) != 0)delete[](*res), (*res) = 0;
		*res = new i64[szbuffer1 * szbuffer2 + 1];
		memset(*res, 0, (szbuffer1* szbuffer2 + 1) * sizeof(i64));
		next_i64(*res, szbuffer1* szbuffer2);
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_i64_2d(i64 * buffer, i32 szbuffer1, i32 szbuffer2)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0)
	{
		memset(buffer, 0, (szbuffer1 * szbuffer2) * sizeof(i64));
		next_i64(buffer, szbuffer1 * szbuffer2);
		return szbuffer1 * szbuffer2;
	}
	return -1;
}

i64 * APIENTRY create_rng_i64_3d(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		i64** res = 0;
		res = &BUFFER_i64_3D;
		if ((*res) != 0)delete[](*res), (*res) = 0;
		* res = new i64[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(*res, 0, (szbuffer1 * szbuffer2 * szbuffer3 + 1) * sizeof(i64));
		next_i64(*res, szbuffer1 * szbuffer2 * szbuffer3);
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_i64_3d(i64 * buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		memset(buffer, 0, (szbuffer1 * szbuffer2 * szbuffer3) * sizeof(i64));
		next_i64(buffer, szbuffer1 * szbuffer2 * szbuffer3);
		return szbuffer1 * szbuffer2 * szbuffer3;
	}
	return -1;
}

i64 ** APIENTRY create_rng_i64_2dj(i32 szbuffer1, i32 szbuffer2)
{
	if (szbuffer1 > 0 && szbuffer2 > 0)
	{
		i64 *** res = 0;
		res = &BUFFER_i64_2DJ;
		if ((*res) != 0) delete_2dj(*res, sz_i64_2dj), (*res) = 0;
		sz_i64_2dj = szbuffer1;

		*res = new i64*[szbuffer1];
		for (int i = 0; i < szbuffer1; ++i) {
			(*res)[i] = new i64[szbuffer2 + 1];
			memset((*res)[i], 0, (szbuffer2 + 1) * sizeof(i64));
		}

		i32 it = 0;
		i64* tmp = new i64[szbuffer1 * szbuffer2 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 + 1) * sizeof(i64));
		next_i64(tmp, szbuffer1 * szbuffer2);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				(*res)[i][j] = tmp[it++];
			}
		}
		delete[] tmp;
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_i64_2dj(i64 ** buffer, i32 szbuffer1, i32 szbuffer2)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0)
	{
		i32 it = 0;
		set_zero_2dj(buffer, szbuffer1, szbuffer2);
		i64* tmp = new i64[szbuffer1 * szbuffer2 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 + 1) * sizeof(i64));
		next_i64(tmp, szbuffer1 * szbuffer2);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				buffer[i][j] = tmp[it++];
			}
		}
		delete[] tmp;
		return szbuffer1 * szbuffer2;
	}
	return -1;
}

i64 *** APIENTRY create_rng_i64_3dj(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		i64 **** res = 0;
		res = &BUFFER_i64_3DJ;
		if ((*res) != 0) delete_3dj(*res, sz_i64_3dj1, sz_i64_3dj2), (*res) = 0;
		sz_i64_3dj1 = szbuffer1; sz_i64_3dj2 = szbuffer2;

		*res = new i64**[szbuffer1];
		for (int i = 0; i < szbuffer1; ++i) {
			(*res)[i] = new i64*[szbuffer2];
			for (int j = 0; j < szbuffer2; ++j) {
				(*res)[i][j] = new i64[szbuffer3 + 1];
				memset((*res)[i][j], 0,( szbuffer3 + 1) * sizeof(i64));
			}
		}
		set_zero_3dj(*res, szbuffer1, szbuffer2, szbuffer3);

		i32 it = 0;
		i64* tmp = new i64[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 * szbuffer3 + 1) * sizeof(i64));
		next_i64(tmp, szbuffer1 * szbuffer2 * szbuffer3);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				for (int z = 0; z < szbuffer3; ++z) {
					(*res)[i][j][z] = tmp[it++];
				}
			}
		}
		delete[] tmp;
		return (*res);
	}
	return 0;
}
i32 APIENTRY fill_rng_i64_3dj(i64 *** buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		set_zero_3dj(buffer, szbuffer1, szbuffer2, szbuffer3);

		i32 it = 0;
		i64* tmp = new i64[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 * szbuffer3 + 1) * sizeof(i64));
		next_i64(tmp, szbuffer1 * szbuffer2 * szbuffer3);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				for (int z = 0; z < szbuffer3; ++z) {
					buffer[i][j][z] = tmp[it++];
				}
			}
		}
		delete[] tmp;
		return szbuffer1 * szbuffer2 * szbuffer3;
	}
	return -1;
}


/* double ----------- -------------- -------------- --------------*/
double*		BUFFER_dbl = 0;
double*		BUFFER_dbl_2D = 0;
double*		BUFFER_dbl_3D = 0;
double**	BUFFER_dbl_2DJ = 0;
double***	BUFFER_dbl_3DJ = 0;
i32			sz_dbl_2d = -1, sz_dbl_3d = -1;
i32			sz_dbl_2dj = -1, sz_dbl_3dj1 = -1, sz_dbl_3dj2 = -1;
double * APIENTRY create_rng_dbl(i32 szbuffer)
{
	if (szbuffer > 0)
	{
		double ** res = 0;
		res = &BUFFER_dbl;
		if ((*res) != 0) delete[](*res), (*res) = 0;
		*res = new double[szbuffer + 1];
		memset((*res), 0, (szbuffer + 1) * sizeof(double));
		next_double((*res), szbuffer);
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_dbl(double * buffer, i32 szbuffer)
{
	if (buffer && szbuffer > 0)
	{
		memset(buffer, 0, szbuffer * sizeof(double));
		next_double(buffer, szbuffer);
		return szbuffer;
	}
	return -1;
}

double * APIENTRY create_rng_dbl_2d(i32 szbuffer1, i32 szbuffer2)
{
	if (szbuffer1 > 0 && szbuffer2 > 0)
	{
		double ** res = 0;
		res = &BUFFER_dbl_2D;
		if ((*res) != 0) delete[](*res), (*res) = 0;
		*res = new double[szbuffer1 * szbuffer2 + 1];
		memset(*res, 0, (szbuffer1 * szbuffer2 + 1) * sizeof(double));
		next_double(*res, szbuffer1 * szbuffer2);
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_dbl_2d(double * buffer, i32 szbuffer1, i32 szbuffer2)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0)
	{
		memset(buffer, 0, (szbuffer1 * szbuffer2) * sizeof(double));
		next_double(buffer, szbuffer1 * szbuffer2);
		return szbuffer1 * szbuffer2;
	}
	return -1;
}

double * APIENTRY create_rng_dbl_3d(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		double ** res = 0;
		res = &BUFFER_dbl_3D;
		if ((*res) != 0) delete[](*res), (*res) = 0;
		*res = new double[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(*res, 0, (szbuffer1 * szbuffer2 * szbuffer3 + 1) * sizeof(double));
		next_double(*res, szbuffer1 * szbuffer2 * szbuffer3);
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_dbl_3d(double * buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		memset(buffer, 0, (szbuffer1 * szbuffer2 * szbuffer3) * sizeof(double));
		next_double(buffer, szbuffer1 * szbuffer2 * szbuffer3);
		return szbuffer1 * szbuffer2 * szbuffer3;
	}
	return -1;
}

double ** APIENTRY create_rng_dbl_2dj(i32 szbuffer1, i32 szbuffer2)
{
	if (szbuffer1 > 0 && szbuffer2 > 0)
	{
		double *** res = 0;
		res = &BUFFER_dbl_2DJ;
		if ((*res) != 0) delete_2dj(*res, sz_dbl_2dj), (*res) = 0;
		sz_dbl_2dj = szbuffer1;

		*res = new double*[szbuffer1];
		for (int i = 0; i < szbuffer1; ++i) {
			(*res)[i] = new double[szbuffer2 + 1];
			memset((*res)[i], 0, (szbuffer2 + 1 ) * sizeof(double));
		}

		i32 it = 0;
		double* tmp = new double[szbuffer1 * szbuffer2 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 + 1) * sizeof(double));
		next_double(tmp, szbuffer1 * szbuffer2);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				(*res)[i][j] = tmp[it++];
			}
		}
		delete[] tmp;
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_dbl_2dj(double ** buffer, i32 szbuffer1, i32 szbuffer2)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0)
	{
		i32 it = 0;
		set_zero_2dj(buffer, szbuffer1, szbuffer2);
		double* tmp = new double[szbuffer1 * szbuffer2 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 + 1) * sizeof(double));
		next_double(tmp, szbuffer1 * szbuffer2);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				buffer[i][j] = tmp[it++];
			}
		}
		delete[] tmp;
		return szbuffer1 * szbuffer2;
	}
	return -1;
}

double *** APIENTRY create_rng_dbl_3dj(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		double **** res = 0;
		res = &BUFFER_dbl_3DJ;
		if ((*res) != 0) delete_3dj(*res, sz_dbl_3dj1, sz_dbl_3dj2), (*res) = 0;
		sz_dbl_3dj1 = szbuffer1; sz_dbl_3dj2 = szbuffer2;

		*res = new double**[szbuffer1];
		for (int i = 0; i < szbuffer1; ++i) {
			(*res)[i] = new double*[szbuffer2];
			for (int j = 0; j < szbuffer2; ++j) {
				(*res)[i][j] = new double[szbuffer3 + 1];
				memset((*res)[i][j], 0, (szbuffer3 + 1) * sizeof(double));
			}
		}
		set_zero_3dj(*res, szbuffer1, szbuffer2, szbuffer3);

		i32 it = 0;
		double* tmp = new double[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 * szbuffer3 + 1) * sizeof(double));
		next_double(tmp, szbuffer1 * szbuffer2 * szbuffer3);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				for (int z = 0; z < szbuffer3; ++z) {
					(*res)[i][j][z] = tmp[it++];
				}
			}
		}
		delete[] tmp;
		return *res;
	}
	return 0;
}
i32 APIENTRY fill_rng_dbl_3dj(double *** buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3)
{
	if (buffer && szbuffer1 > 0 && szbuffer2 > 0 && szbuffer3 > 0)
	{
		set_zero_3dj(buffer, szbuffer1, szbuffer2, szbuffer3);

		i32 it = 0;
		double* tmp = new double[szbuffer1 * szbuffer2 * szbuffer3 + 1];
		memset(tmp, 0, (szbuffer1 * szbuffer2 * szbuffer3 + 1) * sizeof(double));
		next_double(tmp, szbuffer1 * szbuffer2 * szbuffer3);
		for (int i = 0; i < szbuffer1; ++i) {
			for (int j = 0; j < szbuffer2; ++j) {
				for (int z = 0; z < szbuffer3; ++z) {
					buffer[i][j][z] = tmp[it++];
				}
			}
		}
		delete[] tmp;
		return szbuffer1 * szbuffer2 * szbuffer3;
	}
	return -1;
}

/* string -------------- -------------- -------------- --------------*/
b8*		BUFFER_STR = 0;
b8**	BUFFER_STR_LST = 0;
i32		sz_str_lst = -1;
b8 * alpha_string()
{
	i32 inc = 0;
	static b8 res[63] = { 0 };
	memset(res, 0, 63);
	b8 z[] = { 48, 57, 65, 90, 97, 122 };
	int i = 0;
	for (i = 0; i < 6; i += 2) {
		for (b8 j = z[i]; j <= z[i + 1]; j++) {
			res[inc++] = j;
		}
	}
	return res;
}
b8 * APIENTRY create_rng_str(i32 szbuffer)
{
	if (szbuffer > 0) {
		b8** res = 0;
		res = &BUFFER_STR;
		if ((*res) != 0)delete[] * res, (*res) = 0;

		*res = new b8[szbuffer + 1];
		memset(*res, 0, szbuffer + 1);
		b8* alpha_str = alpha_string();

		i32* tmp = new i32[szbuffer + 1];
		memset(tmp, 0, (szbuffer + 1) * sizeof(i32));
		next(tmp, (ui32)szbuffer, 0ui32, 62ui32);

		for (i32 i = 0; i < szbuffer; i++)
			(*res)[i] = alpha_str[tmp[i]];

		delete[] tmp;
		return *res;
	}
	return nullptr;
}
i32 APIENTRY fill_rng_str(b8 * buffer, i32 szbuffer)
{
	if (buffer && szbuffer > 0) {
		b8* alpha_str = alpha_string();

		i32* tmp = new i32[szbuffer + 1];
		memset(tmp, 0, (szbuffer + 1) * sizeof(i32));
		next(tmp, (ui32)szbuffer, 0ui32, 62ui32);

		for (i32 i = 0; i < szbuffer; i++)
			buffer[i] = alpha_str[tmp[i]];

		delete[] tmp;
		return szbuffer;
	}
	return -1;
}

b8 ** APIENTRY create_rng_str_list(i32 szbuffer, i32 _min, i32 _max, i32 *szxbuffer)
{
	if (szbuffer > 0 && szxbuffer) {
		b8 *** res = 0;
		res = &BUFFER_STR_LST;
		if ((*res) != 0)delete_2dj(*res, sz_str_lst), (*res) = 0;
		sz_str_lst = szbuffer;
		next(szxbuffer, szbuffer, _min, _max);

		i32 szsum = 0;
		*res = new b8*[szbuffer];
		for (i32 i = 0; i < szbuffer; ++i) {
			(*res)[i] = new b8[szxbuffer[i] + 1];
			memset((*res)[i], 0, szxbuffer[i] + 1);
			szsum += szxbuffer[i];
		}

		b8* alpha_str = alpha_string();

		i32 it = 0;
		i32* tmp = new i32[szsum + 1];
		memset(tmp, 0, (szsum + 1) * sizeof(i32));
		next(tmp, (ui32)szsum, 0ui32, 62ui32);
		for (int i = 0; i < szbuffer; ++i) {
			for (int j = 0; j < szxbuffer[i]; ++j) {
				(*res)[i][j] = alpha_str[tmp[it++]];
			}
		}
		delete[] tmp;
		return *res;
	}
	return nullptr;
}
i32 APIENTRY fill_rng_str_list(b8 ** buffer, i32 szbuffer,const i32 *szxbuffer)
{
	if (buffer && szxbuffer && szbuffer > 0) {
		i32 szsum = 0;
		b8* alpha_str = alpha_string();
		for (i32 i = 0; i < szbuffer; ++i)
			szsum += szxbuffer[i];

		i32* tmp = new i32[szsum + 1];
		memset(tmp, 0, (szsum + 1) * sizeof(i32));
		next(tmp, (ui32)szsum, 0ui32, 62ui32);

		i32 it = 0;
		for (int i = 0; i < szbuffer; ++i) {
			for (int j = 0; j < szxbuffer[i]; ++j) {
				buffer[i][j] = alpha_str[tmp[it++]];
			}
		}
		delete[] tmp;
		return szsum;
	}
	return -1;
}

void APIENTRY dispose_buffer()
{
	if (BUFFER_BYT != 0)delete[] BUFFER_BYT; BUFFER_BYT = 0;
	if (BUFFER_BYT_2D != 0)delete[] BUFFER_BYT_2D; BUFFER_BYT_2D = 0;
	if (BUFFER_BYT_3D != 0)delete[] BUFFER_BYT_3D; BUFFER_BYT_3D = 0;
	if (BUFFER_BYT_2DJ != 0)delete_2dj(BUFFER_BYT_2DJ, sz_byt_2dj); BUFFER_BYT_2DJ = 0;
	if (BUFFER_BYT_3DJ != 0)delete_3dj(BUFFER_BYT_3DJ, sz_byt_3dj1, sz_byt_3dj2); BUFFER_BYT_3DJ = 0;

	if (BUFFER_i32 != 0)delete[] BUFFER_i32; BUFFER_i32 = 0;
	if (BUFFER_i32_2D != 0)delete[] BUFFER_i32_2D; BUFFER_i32_2D = 0;
	if (BUFFER_i32_3D != 0)delete[] BUFFER_i32_3D; BUFFER_i32_3D = 0;
	if (BUFFER_i32_2DJ != 0)delete_2dj(BUFFER_i32_2DJ, sz_i32_2dj); BUFFER_i32_2DJ = 0;
	if (BUFFER_i32_3DJ != 0)delete_3dj(BUFFER_i32_3DJ, sz_i32_3dj1, sz_i32_3dj2); BUFFER_i32_3DJ = 0;

	if (BUFFER_i64 != 0)delete[] BUFFER_i64; BUFFER_i64 = 0;
	if (BUFFER_i64_2D != 0)delete[] BUFFER_i64_2D; BUFFER_i64_2D = 0;
	if (BUFFER_i64_3D != 0)delete[] BUFFER_i64_3D; BUFFER_i64_3D = 0;
	if (BUFFER_i64_2DJ != 0)delete_2dj(BUFFER_i64_2DJ, sz_i64_2dj); BUFFER_i64_2DJ = 0;
	if (BUFFER_i64_3DJ != 0)delete_3dj(BUFFER_i64_3DJ, sz_i64_3dj1, sz_i64_3dj2); BUFFER_i64_3DJ = 0;

	if (BUFFER_dbl != 0)delete[] BUFFER_dbl; BUFFER_dbl = 0;
	if (BUFFER_dbl_2D != 0)delete[] BUFFER_dbl_2D; BUFFER_dbl_2D = 0;
	if (BUFFER_dbl_3D != 0)delete[] BUFFER_dbl_3D; BUFFER_dbl_3D = 0;
	if (BUFFER_dbl_2DJ != 0)delete_2dj(BUFFER_dbl_2DJ, sz_dbl_2dj); BUFFER_dbl_2DJ = 0;
	if (BUFFER_dbl_3DJ != 0)delete_3dj(BUFFER_dbl_3DJ, sz_dbl_3dj1, sz_dbl_3dj2); BUFFER_dbl_3DJ = 0;

	if (BUFFER_STR != 0)delete[] BUFFER_STR; BUFFER_STR = 0;
	if (BUFFER_STR_LST != 0)delete_2dj(BUFFER_STR_LST, sz_str_lst); BUFFER_STR_LST = 0;

	sz_byt_2d = -1; sz_byt_3d = -1;
	sz_byt_2dj = -1; sz_byt_3dj1 = -1; sz_byt_3dj2 = -1;
	sz_i32_2d = -1; sz_i32_3d = -1;
	sz_i32_2dj = -1; sz_i32_3dj1 = -1; sz_i32_3dj2 = -1;
	sz_i64_2d = -1; sz_i64_3d = -1;
	sz_i64_2dj = -1; sz_i64_3dj1 = -1; sz_i64_3dj2 = -1;
	sz_dbl_2d = -1; sz_dbl_3d = -1;
	sz_dbl_2dj = -1; sz_dbl_3dj1 = -1; sz_dbl_3dj2 = -1;
	sz_str_lst = -1;
}