﻿Option Strict On
Option Explicit On
Imports System.Text
Imports System.Runtime.InteropServices

Public Module PassingArray
   Private ReadOnly Rand As New Random
   Private ReadOnly Agch As ArrayGcHandler = New ArrayGcHandler
   Public Sub Main()
      Dim sz = 100I

      PassingByte(sz)
      PassingInt32(sz)
      PassingInt64(sz)
      PassingDouble(sz)
      PassingString(sz)

      'WICHTIG
      'Jede "CreateRngT"-Funktion nutzt ein Puffer in der DLL.
      'Der Puffer (Allokation) wird automatisch zurückgesetzt sollte 
      'eine "CreateRngT"-Funktion zweimal hintereinander verwendet
      'werden.

      'DisposePassing() setzt ALLE allozierten Puffer in der DLL korrekt 
      'zurück. DisposePassing() darf überall und nach jeder Tätigkeit 
      'verwendet werden
      DisposePassing()

      Console.WriteLine()
      Console.WriteLine("Finish")
      Console.ReadLine()
   End Sub
   Private Sub PassingByte(sz As Int32)
      '1D Array
      Dim b1 = New Byte(sz - 1) {}
      Dim l1 = FillRngByt(b1, sz)

      Dim b2 = New Byte(sz - 1) {}
      Dim p1 = CreateRngByt(sz)
      Marshal.Copy(p1, b2, 0, b2.Length)

      'Jagged 2D
      Dim bb1 = Get2dj(Of Byte)(sz, 10)
      Dim pp1 = agch.GetPtr(bb1)
      Dim ll1 = FillRngByt2dj(pp1, bb1.Length, bb1(0).Length)
      Dim bb2 = GetJagged(Of Byte)(pp1, sz, 10)

      Dim pp2 = CreateRngByt2dj(sz, 10)
      Dim bb3 = GetJagged(Of Byte)(pp2, sz, 10)

      'Jagged 3D
      Dim bbb1 = Get3dj(Of Byte)(sz, 10, 10)
      Dim ppp1 = agch.GetPtr(bbb1)
      Dim lll1 = FillRngByt3dj(ppp1, bbb1.Length, bbb1(0).Length, bbb1(0)(0).Length)
      GetJagged(bbb1, ppp1, sz, 10, 10)

      Dim ppp2 = CreateRngByt3dj(sz, 10, 10)
      Dim bbb3 = GetJagged(Of Byte)(ppp2, sz, 10, 10)

      '2D
      Dim bb4 = Get2D(Of Byte)(sz, 10)
      Dim pp3 = Agch.GetPtr(bb4)
      Dim ll2 = FillRngByt2d(pp3, bb4.GetLength(0), bb4.GetLength(1))
      Dim bb5 = GetArray(Of Byte)(pp3, sz, 10)

      Dim pp4 = CreateRngByt2d(sz, 10)
      Dim bb6 = GetArray(Of Byte)(pp4, sz, 10)

      '3D
      Dim bbb4 = Get3D(Of Byte)(sz, 10, 10)
      Dim ppp3 = Agch.GetPtr(bbb4)
      Dim lll2 = FillRngByt3d(ppp3, bbb4.GetLength(0), bbb4.GetLength(1), bbb4.GetLength(2))
      GetArray(bbb4, ppp3, sz, 10, 10)

      Dim ppp4 = CreateRngByt3d(sz, 10, 10)
      Dim bbb6 = GetArray(Of Byte)(ppp4, sz, 10, 10)

      Agch.Dispose()
      'DisposePassing()
   End Sub
   Private Sub PassingInt32(sz As Int32)
      '1D Array
      Dim i1 = New Int32(sz - 1) {}
      Dim l1 = FillRngI32(i1, sz)

      Dim i2 = New Int32(sz - 1) {}
      Dim p1 = CreateRngI32(sz)
      Marshal.Copy(p1, i2, 0, i2.Length)

      'Jagged 2D
      Dim ii1 = Get2dj(Of Int32)(sz, 10)
      Dim pp1 = agch.GetPtr(ii1)
      Dim ll1 = FillRngI322dj(pp1, ii1.Length, ii1(0).Length)
      Dim ii2 = GetJagged(Of Int32)(pp1, sz, 10)

      Dim pp2 = CreateRngI322dj(sz, 10)
      Dim ii3 = GetJagged(Of Int32)(pp2, sz, 10)

      'Jagged 3D
      Dim iii1 = Get3dj(Of Int32)(sz, 10, 10)
      Dim ppp1 = agch.GetPtr(iii1)
      Dim lll1 = FillRngI323dj(ppp1, iii1.Length, iii1(0).Length, iii1(0)(0).Length)
      Dim iii2 = GetJagged(Of Int32)(ppp1, sz, 10, 10)

      Dim ppp2 = CreateRngI323dj(sz, 10, 10)
      Dim iii3 = GetJagged(Of Int32)(ppp2, sz, 10, 10)

      '2D
      Dim ii4 = Get2D(Of Int32)(sz, 10)
      Dim pp3 = Agch.GetPtr(ii4)
      Dim ll2 = FillRngI322d(pp3, ii4.GetLength(0), ii4.GetLength(1))
      Dim ii5 = GetArray(Of Int32)(pp3, sz, 10)

      Dim pp4 = CreateRngI322d(sz, 10)
      Dim ii6 = GetArray(Of Int32)(pp4, sz, 10)

      '3D
      Dim iii4 = Get3D(Of Int32)(sz, 10, 10)
      Dim ppp3 = Agch.GetPtr(iii4)
      Dim lll2 = FillRngI323d(ppp3, iii4.GetLength(0), iii4.GetLength(1), iii4.GetLength(2))
      Dim iii5 = GetArray(Of Int32)(ppp3, sz, 10, 10)

      Dim ppp4 = CreateRngI323d(sz, 10, 10)
      Dim iii6 = GetArray(Of Int32)(ppp4, sz, 10, 10)

      Agch.Dispose()
      'DisposePassing()
   End Sub
   Private Sub PassingInt64(sz As Int32)
      '1D Array
      Dim i1 = New Int64(sz - 1) {}
      Dim l1 = FillRngI64(i1, sz)

      Dim i2 = New Int64(sz - 1) {}
      Dim p1 = CreateRngI64(sz)
      Marshal.Copy(p1, i2, 0, i2.Length)

      'Jagged 2D
      Dim ii1 = Get2dj(Of Int64)(sz, 10)
      Dim pp1 = agch.GetPtr(ii1)
      Dim ll1 = FillRngI642dj(pp1, ii1.Length, ii1(0).Length)
      Dim ii2 = GetJagged(Of Int64)(pp1, sz, 10)

      Dim pp2 = CreateRngI642dj(sz, 10)
      Dim ii3 = GetJagged(Of Int64)(pp2, sz, 10)

      'Jagged 3D
      Dim iii1 = Get3dj(Of Int64)(sz, 10, 10)
      Dim ppp1 = agch.GetPtr(iii1)
      Dim lll1 = FillRngI643dj(ppp1, iii1.Length, iii1(0).Length, iii1(0)(0).Length)
      Dim iii2 = GetJagged(Of Int64)(ppp1, sz, 10, 10)

      Dim ppp2 = CreateRngI643dj(sz, 10, 10)
      Dim iii3 = GetJagged(Of Int64)(ppp2, sz, 10, 10)

      '2D
      Dim ii4 = Get2D(Of Int64)(sz, 10)
      Dim pp3 = Agch.GetPtr(ii4)
      Dim ll2 = FillRngI642d(pp3, ii4.GetLength(0), ii4.GetLength(1))
      Dim ii5 = GetArray(Of Int64)(pp3, sz, 10)

      Dim pp4 = CreateRngI642d(sz, 10)
      Dim ii6 = GetArray(Of Int64)(pp4, sz, 10)

      '3D
      Dim iii4 = Get3D(Of Int64)(sz, 10, 10)
      Dim ppp3 = Agch.GetPtr(iii4)
      Dim lll2 = FillRngI643d(ppp3, iii4.GetLength(0), iii4.GetLength(1), iii4.GetLength(2))
      Dim iii5 = GetArray(Of Int64)(ppp3, sz, 10, 10)

      Dim ppp4 = CreateRngI643d(sz, 10, 10)
      Dim iii6 = GetArray(Of Int64)(ppp4, sz, 10, 10)

      Agch.Dispose()
      'DisposePassing()
   End Sub
   Private Sub PassingDouble(sz As Int32)
      '1D Array
      Dim d1 = New Double(sz - 1) {}
      Dim l1 = FillRngDbl(d1, sz)

      Dim d2 = New Double(sz - 1) {}
      Dim p1 = CreateRngDbl(sz)
      Marshal.Copy(p1, d2, 0, d2.Length)

      'Jagged 2D
      Dim dd1 = Get2dj(Of Double)(sz, 10)
      Dim pp1 = agch.GetPtr(dd1)
      Dim ll1 = FillRngDbl2dj(pp1, dd1.Length, dd1(0).Length)
      Dim dd2 = GetJagged(Of Double)(pp1, sz, 10)

      Dim pp2 = CreateRngDbl2dj(sz, 10)
      Dim dd3 = GetJagged(Of Double)(pp2, sz, 10)

      'Jagged 3D
      Dim ddd1 = Get3dj(Of Double)(sz, 10, 10)
      Dim ppp1 = agch.GetPtr(ddd1)
      Dim lll1 = FillRngDbl3dj(ppp1, ddd1.Length, ddd1(0).Length, ddd1(0)(0).Length)
      Dim ddd2 = GetJagged(Of Double)(ppp1, sz, 10, 10)

      Dim ppp2 = CreateRngDbl3dj(sz, 10, 10)
      Dim ddd3 = GetJagged(Of Double)(ppp2, sz, 10, 10)

      '2D
      Dim dd4 = Get2D(Of Double)(sz, 10)
      Dim pp3 = Agch.GetPtr(dd4)
      Dim ll2 = FillRngdbl2d(pp3, dd4.GetLength(0), dd4.GetLength(1))
      Dim dd5 = GetArray(Of Double)(pp3, sz, 10)

      Dim pp4 = CreateRngdbl2d(sz, 10)
      Dim dd6 = GetArray(Of Double)(pp4, sz, 10)

      '3D
      Dim ddd4 = Get3D(Of Double)(sz, 10, 10)
      Dim ppp3 = Agch.GetPtr(ddd4)
      Dim lll2 = FillRngdbl3d(ppp3, ddd4.GetLength(0), ddd4.GetLength(1), ddd4.GetLength(2))
      Dim ddd5 = GetArray(Of Double)(ppp3, sz, 10, 10)

      Dim ppp4 = CreateRngdbl3d(sz, 10, 10)
      Dim ddd6 = GetArray(Of Double)(ppp4, sz, 10, 10)

      Agch.Dispose()
      'DisposePassing()
   End Sub
   Private Sub PassingString(sz As Int32)
      'Strings
      Dim s1 = New String(New Char(sz - 1) {})
      Dim len = s1.Length
      Dim p1 = agch.GetPtr(s1)
      Dim l1 = FillRngStr(p1, sz)
      GetString(s1, p1, sz)

      Dim p2 = CreateRngStr(sz)
      Dim s3 = GetString(p2, sz)
      len = s3.Length
      agch.Dispose()

      'String List
      Dim szx1 = GetRngSzList(sz, 50, 100)
      Dim pp1 = GetPtrEmpty(sz, szx1)
      Dim ll1 = FillRngStrList(pp1, sz, szx1)
      Dim ss1 = GetStringList(pp1, sz, szx1)

      Dim szx2 = New Int32(sz - 1) {} 'Wird in der Dll gefüllt
      Dim pp2 = CreateRngStrList(sz, 50, 100, szx2)
      Dim ss2 = GetStringList(pp2, sz, szx2)

      'DisposePassing()

      ''So wird es in .Net gemacht
      ''**************************
      Dim s4 = CreateRngString(sz)
      Dim ss3 = CreateStrArray(sz)
   End Sub

   Private Function Get2dj(Of T As Structure)(sz1 As Int32, sz2 As Int32) As T()()
      Dim res = New T(sz1 - 1)() {}
      Enumerable.Range(0, res.Length).ToList.ForEach(Sub(x) res(x) = New T(sz2 - 1) {})
      Return res
   End Function
   Private Function Get3dj(Of T As Structure)(sz1 As Int32, sz2 As Int32, sz3 As Int32) As T()()()
      Dim res = New T(sz1 - 1)()() {}
      Enumerable.Range(0, res.Length).ToList.ForEach(Sub(x) res(x) = Get2dj(Of T)(sz2, sz3))
      Return res
   End Function
   Private Function Get2D(Of T As Structure)(sz1 As Int32, sz2 As Int32) As T(,)
      Return New T(sz1 - 1, sz2 - 1) {}
   End Function
   Private Function Get3D(Of T As Structure)(sz1 As Int32, sz2 As Int32, sz3 As Int32) As T(,,)
      Return New T(sz1 - 1, sz2 - 1, sz3 - 1) {}
   End Function

   Private Sub GetJagged(Of T As Structure)(ByRef jagged As T()(),
                                            ptr As IntPtr,
                                            sz1 As Int32,
                                            sz2 As Int32)
      jagged = GetJagged(Of T)(ptr, sz1, sz2)
   End Sub
   Private Function GetJagged(Of T As Structure)(ptr As IntPtr,
                                                 sz1 As Int32,
                                                 sz2 As Int32) As T()()
      Dim p = New IntPtr(sz1 - 1) {}
      Marshal.Copy(ptr, p, 0, p.Length)

      Dim tmp() As T
      Dim pp As Pointer(Of T)
      Dim res = New T(sz1 - 1)() {}
      For i As Int32 = 0 To sz1 - 1
         tmp = New T(sz2 - 1) {}
         pp = p(i)
         For j As Int32 = 0 To sz2 - 1
            tmp(j) = pp.Target
            pp += 1
         Next
         res(i) = tmp
      Next
      Return res
   End Function
   Private Sub GetJagged(Of T As Structure)(ByRef jagged As T()()(),
                                            ptr As IntPtr,
                                            sz1 As Int32,
                                            sz2 As Int32,
                                            sz3 As Int32)
      jagged = GetJagged(Of T)(ptr, sz1, sz2, sz3)
   End Sub
   Private Function GetJagged(Of T As Structure)(ptr As IntPtr,
                                                 sz1 As Int32,
                                                 sz2 As Int32,
                                                 sz3 As Int32) As T()()()
      Dim p1 = New IntPtr(sz1 - 1) {}
      Marshal.Copy(ptr, p1, 0, p1.Length)

      Dim tmp() As T
      Dim tmp1()() As T
      Dim p2() As IntPtr
      Dim pp As Pointer(Of T)
      Dim res = New T(sz1 - 1)()() {}
      For i As Int32 = 0 To sz1 - 1
         tmp1 = New T(sz2 - 1)() {}
         p2 = New IntPtr(sz2 - 1) {}
         Marshal.Copy(p1(i), p2, 0, p2.Length)
         For j As Int32 = 0 To sz2 - 1
            tmp = New T(sz3 - 1) {}
            pp = Nothing
            pp = p2(j)
            For k As Int32 = 0 To sz3 - 1
               tmp(k) = pp.Target
               pp += 1
            Next
            tmp1(j) = tmp
         Next
         res(i) = tmp1
      Next
      'AddrOfPinnedObject-Pointer (intPtr) müssen nicht zurückgesetzt 
      'werden, das sie in den verwalteten Speicherbereich zeigen. Der 
      'GC räumt den Pointer selber weg.
      Return res
   End Function

   Private Sub GetArray(Of T As Structure)(ByRef arr As T(,),
                                                ptr As IntPtr,
                                                sz1 As Int32,
                                                sz2 As Int32)
      Dim pp As Pointer(Of T) = ptr
      'arr = New T(sz1 - 1, sz2 - 1) {}
      For x As Int32 = 0 To sz1 * sz2 - 1
         arr(x \ sz2, x Mod sz2) = pp.Target
         pp += 1
      Next
   End Sub
   Private Function GetArray(Of T As Structure)(ptr As IntPtr,
                                                sz1 As Int32,
                                                sz2 As Int32) As T(,)
      Dim pp As Pointer(Of T) = ptr
      Dim res = New T(sz1 - 1, sz2 - 1) {}
      For x As Int32 = 0 To sz1 * sz2 - 1
         res(x \ sz2, x Mod sz2) = pp.Target
         pp += 1
      Next
      Return res
   End Function
   Private Sub GetArray(Of T As Structure)(ByRef arr As T(,,),
                                           ptr As IntPtr,
                                           sz1 As Int32,
                                           sz2 As Int32,
                                           sz3 As Int32)
      Dim i, j, k, l As Int32
      Dim pp As Pointer(Of T) = ptr
      For x As Int32 = 0 To sz1 * sz2 * sz3 - 1
         'https://stackoverflow.com/questions/7367770/how-to-flatten-or-index-3d-array-in-1d-array/7367808#7367808
         k = x \ (sz1 * sz2)
         l = x
         l -= (k * sz1 * sz2)
         j = l \ sz1
         i = l Mod sz1
         arr(i, j, k) = pp.Target
         pp += 1
      Next
   End Sub
   Private Function GetArray(Of T As Structure)(ptr As IntPtr,
                                                sz1 As Int32,
                                                sz2 As Int32,
                                                sz3 As Int32) As T(,,)
      Dim i, j, k, l As Int32
      Dim pp As Pointer(Of T) = ptr
      Dim res = New T(sz1 - 1, sz2 - 1, sz3 - 1) {}
      For x As Int32 = 0 To sz1 * sz2 * sz3 - 1
         'https://stackoverflow.com/questions/7367770/how-to-flatten-or-index-3d-array-in-1d-array/7367808#7367808
         k = x \ (sz1 * sz2)
         l = x
         l -= (k * sz1 * sz2)
         j = l \ sz1
         i = l Mod sz1
         res(i, j, k) = pp.Target
         pp += 1
      Next
      Return res
   End Function

   Private Sub GetString(ByRef str As String, ptr As IntPtr, sz As Int32)
      str = GetString(ptr, sz)
   End Sub
   Private Function GetString(ptr As IntPtr, sz As Int32) As String
      Dim b = New Byte(sz - 1) {}
      Marshal.Copy(ptr, b, 0, b.Length)
      Return Encoding.UTF8.GetString(b)
   End Function
   Private Function GetPtrEmpty(sz As Int32, szx() As Int32) As IntPtr
      Dim res = New String(sz - 1) {}
      Enumerable.Range(0, sz).ToList.ForEach(Sub(x) res(x) = New String(New Char(szx(x) - 1) {}))
      Return Agch.GetPtr(res)
   End Function
   Private Function GetRngSzList(sz As Int32, _min As Int32, _max As Int32) As Int32()
      Dim res = New Int32(sz - 1) {}
      Enumerable.Range(0, sz).ToList.ForEach(Sub(x) res(x) = rand.Next(_min, _max + 1))
      Return res
   End Function
   Private Sub GetStringList(ByRef str() As String, ptr As IntPtr, sz As Int32, szx() As Int32)
      str = GetStringList(ptr, sz, szx)
   End Sub
   Private Function GetStringList(ptr As IntPtr, sz As Int32, szx() As Int32) As String()
      Dim p = New IntPtr(sz - 1) {}
      Marshal.Copy(ptr, p, 0, p.Length)

      Dim res = New String(sz - 1) {}
      Enumerable.Range(0, sz).ToList.ForEach(Sub(x) res(x) = GetString(p(x), szx(x)))
      Return res
   End Function

#Region "Methodes"
   Private Sub SetValue(ByVal arr(,) As Byte)
      Dim sz1 = arr.GetLength(0)
      Dim sz2 = arr.GetLength(1)
      Dim valu As Byte = 0
      For i As Int32 = 0 To sz1 - 1
         For j As Int32 = 0 To sz2 - 1
            arr(i, j) = valu
            valu = CByte((valu + 1I) Mod 256)
         Next
      Next
   End Sub
   Private Sub SetValue(ByVal arr(,,) As Byte)
      Dim sz1 = arr.GetLength(0)
      Dim sz2 = arr.GetLength(1)
      Dim sz3 = arr.GetLength(2)
      Dim valu As Byte = 0
      For i As Int32 = 0 To sz1 - 1
         For j As Int32 = 0 To sz2 - 1
            For k As Int32 = 0 To sz3 - 1
               arr(i, j, k) = valu
               valu = CByte((valu + 1I) Mod 256)
            Next
         Next
      Next
   End Sub

   Private Function CreateRngString(sz As Int32) As String
      Dim salpha = AlphaString()
      Dim res = New StringBuilder(sz)
      Enumerable.Range(0, sz).ToList.ForEach(Sub(x) res.Append(salpha(Rand.Next(salpha.Length))))
      Return res.ToString
   End Function
   Private Function CreateStrArray(sz As Int32) As String()
      Dim salpha = AlphaString()
      Dim res = New String(sz - 1) {}
      Dim sb As StringBuilder, len As Int32
      For i As Int32 = 0 To res.Length - 1
         sb = New StringBuilder(20)
         len = Rand.Next(10, 21)
         For j As Int32 = 0 To len - 1
            sb.Append(salpha(Rand.Next(salpha.Length)))
         Next
         res(i) = sb.ToString
      Next
      Return res
   End Function
   <DebuggerHidden()>
   Private Function AlphaString() As String
      Dim res As New StringBuilder(62)
      Dim z() As Byte = {48, 57, 65, 90, 97, 122}
      For i As Int32 = 0 To z.Length - 1 Step 2
         For j As Byte = z(i) To z(i + 1)
            res.Append(ChrW(j))
         Next
      Next
      If res.Length > 0 Then Return res.ToString
      Return String.Empty
   End Function

   Private Function Equals(Of T As Structure)(arr1(,) As T, arr2(,) As T) As Boolean
      Dim sz1 = arr1.GetLength(0)
      Dim sz2 = arr1.GetLength(1)

      For i As Int32 = 0 To sz1 - 1
         For j As Int32 = 0 To sz2 - 1
            If Not arr1(i, j).Equals(arr2(i, j)) Then
               Return False
            End If
         Next
      Next
      Return True
   End Function
   Private Function Equals(Of T As Structure)(arr1(,,) As T, arr2(,,) As T) As Boolean
      Dim sz1 = arr1.GetLength(0)
      Dim sz2 = arr1.GetLength(1)
      Dim sz3 = arr1.GetLength(2)

      For i As Int32 = 0 To sz1 - 1
         For j As Int32 = 0 To sz2 - 1
            For k As Int32 = 0 To sz3 - 1
               If Not arr1(i, j, k).Equals(arr2(i, j, k)) Then
                  Return False
               End If
            Next
         Next
      Next
      Return True
   End Function
#End Region
End Module
