﻿Option Strict On
Option Explicit On
Imports System.Runtime.InteropServices

Friend Structure Pointer(Of T As Structure)
   'https://gist.github.com/NaxAlpha/8f4e6035a060c6b93fe5d6b8f7bfaeae
   Private Ptr As IntPtr
   Private Shared ReadOnly TypeSize As Int32 = Marshal.SizeOf(Of T)
   Default Friend Property Value(idx As IntPtr) As T
      Get
         Return Marshal.PtrToStructure(Of T)(Me.Ptr + (idx.ToInt32 * TypeSize))
      End Get
      Set(value As T)
         Marshal.StructureToPtr(Of T)(value, Me.Ptr + (idx.ToInt32 * TypeSize), False)
      End Set
   End Property
   Friend Property Target As T
      Get
         Return Me.Value(IntPtr.Zero)
      End Get
      Set(value As T)
         Me.Value(IntPtr.Zero) = value
      End Set
   End Property
   Friend Function ToPointer() As IntPtr
      Return Me.Ptr
   End Function
   Public Shared Narrowing Operator CType(this As Pointer(Of T)) As T
      Return this(IntPtr.Zero)
   End Operator
   Public Shared Operator +(this As Pointer(Of T), that As Int32) As Pointer(Of T)
      Return this.Ptr + (that * TypeSize)
   End Operator
   Public Shared Operator -(this As Pointer(Of T), that As Int32) As Pointer(Of T)
      Return this.Ptr - (that * TypeSize)
   End Operator
   Public Shared Narrowing Operator CType(this As Pointer(Of T)) As IntPtr
      Return this.Ptr
   End Operator
   Public Shared Widening Operator CType(this As IntPtr) As Pointer(Of T)
      Return New Pointer(Of T)() With {.Ptr = this}
   End Operator
   Private Sub New(Optional b As Boolean = True)
      Throw New Exception("Cannot get pointer of .Net object")
   End Sub
   Private Sub New(obj As T)
      Throw New Exception("Cannot get pointer of .Net object")
   End Sub
End Structure
